"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var makeError = require("make-error"), coreConstants = require("@remirror/core-constants"), _defineProperty = require("@babel/runtime/helpers/defineProperty"), deepmerge = require("deepmerge"), fastDeepEqual = require("fast-deep-equal"), omit = require("object.omit"), object_pick = require("object.pick"), caseAnything = require("case-anything"), throttleDebounce = require("throttle-debounce");

function _interopDefault(e) {
  return e && e.__esModule ? e : {
    default: e
  };
}

var TypeName, _defineProperty__default = _interopDefault(_defineProperty), deepmerge__default = _interopDefault(deepmerge), fastDeepEqual__default = _interopDefault(fastDeepEqual), omit__default = _interopDefault(omit), object_pick__default = _interopDefault(object_pick);

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;
  if ("undefined" == typeof Symbol || null == o[Symbol.iterator]) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && "number" == typeof o.length) {
      it && (o = it);
      var i = 0, F = function() {};
      return {
        s: F,
        n: function() {
          return i >= o.length ? {
            done: !0
          } : {
            done: !1,
            value: o[i++]
          };
        },
        e: function(_e) {
          throw _e;
        },
        f: F
      };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var err, normalCompletion = !0, didErr = !1;
  return {
    s: function() {
      it = o[Symbol.iterator]();
    },
    n: function() {
      var step = it.next();
      return normalCompletion = step.done, step;
    },
    e: function(_e2) {
      didErr = !0, err = _e2;
    },
    f: function() {
      try {
        normalCompletion || null == it.return || it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

function _unsupportedIterableToArray(o, minLen) {
  if (o) {
    if ("string" == typeof o) return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    return "Object" === n && o.constructor && (n = o.constructor.name), "Map" === n || "Set" === n ? Array.from(o) : "Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n) ? _arrayLikeToArray(o, minLen) : void 0;
  }
}

function _arrayLikeToArray(arr, len) {
  (null == len || len > arr.length) && (len = arr.length);
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter((function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    }))), keys.push.apply(keys, symbols);
  }
  return keys;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach((function(key) {
      _defineProperty__default.default(target, key, source[key]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach((function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    }));
  }
  return target;
}

function Cast(parameter) {
  return parameter;
}

function entries(value) {
  return Object.entries(value);
}

function keys(value) {
  return Object.keys(value);
}

function values(value) {
  return Object.values(value);
}

function includes(array, item, fromIndex) {
  return array.includes(item, fromIndex);
}

function object(value) {
  return Object.assign(Object.create(null), value);
}

function bool(value) {
  return !!value;
}

function toString(value) {
  return Object.prototype.toString.call(value);
}

function not(predicate) {
  return a => !predicate(a);
}

function getObjectType(value) {
  return toString(value).slice(8, -1);
}

function isOfType(type, test) {
  return value => typeof value === type && (!test || test(value));
}

function isObjectOfType(type) {
  return value => getObjectType(value) === type;
}

function isDirectInstanceOf(instance, Constructor) {
  return Object.getPrototypeOf(instance) === Constructor.prototype;
}

!function(TypeName) {
  TypeName.Object = "Object", TypeName.RegExp = "RegExp", TypeName.Date = "Date", 
  TypeName.Promise = "Promise", TypeName.Error = "Error", TypeName.Map = "Map", TypeName.Set = "Set";
}(TypeName || (TypeName = {}));

var isUndefined = isOfType("undefined"), isString = isOfType("string"), isNumber = isOfType("number", value => !Number.isNaN(value)), isFunction = isOfType("function");

function isNull(value) {
  return null === value;
}

function isClass(value) {
  return isFunction(value) && value.toString().startsWith("class ");
}

function isBoolean(value) {
  return !0 === value || !1 === value;
}

var isSymbol = isOfType("symbol");

function isInteger(value) {
  return Number.isInteger(value);
}

function isSafeInteger(value) {
  return Number.isSafeInteger(value);
}

function isPlainObject(value) {
  if (getObjectType(value) !== TypeName.Object) return !1;
  var prototype = Object.getPrototypeOf(value);
  return null === prototype || prototype === Object.getPrototypeOf({});
}

function isPrimitive(value) {
  return null == value || /^[bns]/.test(typeof value);
}

function isNullOrUndefined(value) {
  return isNull(value) || isUndefined(value);
}

function isObject(value) {
  return !isNullOrUndefined(value) && (isFunction(value) || isOfType("object")(value));
}

function isInstanceOf(Constructor) {
  return value => isObject(value) && value instanceof Constructor;
}

function isNativePromise(value) {
  return isObjectOfType(TypeName.Promise)(value);
}

var hasPromiseAPI = value => !isNull(value) && isObject(value) && isFunction(value.then) && isFunction(value.catch);

function isPromise(value) {
  return isNativePromise(value) || hasPromiseAPI(value);
}

var isRegExp = isObjectOfType(TypeName.RegExp), isDate = isObjectOfType(TypeName.Date), isError = isObjectOfType(TypeName.Error);

function isMap(value) {
  return isObjectOfType(TypeName.Map)(value);
}

function isSet(value) {
  return isObjectOfType(TypeName.Set)(value);
}

function isEmptyObject(value) {
  return isObject(value) && !isMap(value) && !isSet(value) && 0 === Object.keys(value).length;
}

var isArray = Array.isArray;

function isEmptyArray(value) {
  return isArray(value) && 0 === value.length;
}

var isRemirrorType = value => isObject(value);

function isIdentifierOfType(value, type) {
  return isArray(type) ? includes(type, value[coreConstants.__INTERNAL_REMIRROR_IDENTIFIER_KEY__]) : type === value[coreConstants.__INTERNAL_REMIRROR_IDENTIFIER_KEY__];
}

function capitalize(string) {
  return string.charAt(0).toUpperCase() + string.slice(1);
}

function format(value) {
  return value = value.trim(), /^(?:webOS|i(?:OS|P))/.test(value) ? value : capitalize(value);
}

function callIfDefined(fn) {
  if (isFunction(fn)) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) args[_key - 1] = arguments[_key];
    fn(...args);
  }
}

function findMatches(text, regexp) {
  var match, runWhile = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : match => bool(match), results = [], flags = regexp.flags;
  flags.includes("g") || (regexp = new RegExp(regexp.source, "g".concat(flags)));
  do {
    (match = regexp.exec(text)) && results.push(match);
  } while (runWhile(match));
  return regexp.lastIndex = 0, results;
}

function cleanupOS(os, pattern, label) {
  return pattern && label && (os = os.replace(new RegExp(pattern, "i"), label)), format(os.replace(/ ce$/i, " CE").replace(/\bhpw/i, "web").replace(/\bMacintosh\b/, "Mac OS").replace(/_powerpc\b/i, " OS").replace(/\b(os x) [^\d ]+/i, "$1").replace(/\bMac (OS X)\b/, "$1").replace(/\/(\d)/, " $1").replace(/_/g, ".").replace(/(?: bepc|[ .]*fc[\d .]+)$/i, "").replace(/\bx86\.64\b/gi, "x86_64").replace(/\b(Windows Phone) OS\b/, "$1").replace(/\b(Chrome OS \w+) [\d.]+\b/, "$1").split(" on ")[0]);
}

function isAndroidOS() {
  var ua = navigator.userAgent, match = new RegExp("\\bAndroid(?:/[\\d.]+|[ \\w.]*)", "i").exec(ua);
  return !!match && cleanupOS(match[0], "Android", "Android").includes("Android");
}

function randomFloat(min, max) {
  return max || (max = min, min = 0), Math.random() * (max - min + 1) + min;
}

function randomInt(min, max) {
  return Math.floor(randomFloat(min, max));
}

function startCase(string) {
  return string.replace(/_/g, " ").replace(/([a-z])([A-Z])/g, (_, $1, $2) => "".concat($1, " ").concat($2)).replace(/(\s|^)(\w)/g, (_, $1, $2) => "".concat($1).concat($2.toUpperCase()));
}

function n() {
  var time = Date.now(), last = n.last || time;
  return n.last = time > last ? time : last + 1;
}

function uniqueId() {
  var prefix = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : "";
  return "".concat(prefix).concat(n().toString(36));
}

function take(array, number) {
  return number = Math.max(Math.min(0, number), number), array.slice(0, number);
}

function omitUndefined(object) {
  return omit__default.default(object, value => !isUndefined(value));
}

function clone(value) {
  if (!isPlainObject(value)) throw new Error("An invalid value was passed into this clone utility. Expected a plain object");
  return _objectSpread({}, value);
}

function shallowClone(value) {
  var clone = Object.create(Object.getPrototypeOf(value)), descriptors = Object.getOwnPropertyDescriptors(value);
  return Object.defineProperties(clone, descriptors), clone;
}

n.last = 0;

var isEqual = fastDeepEqual__default.default;

function uniqueArray(array) {
  var fromStart = arguments.length > 1 && void 0 !== arguments[1] && arguments[1], array_ = fromStart ? [ ...array ].reverse() : array, set = new Set(array_);
  return fromStart ? [ ...set ].reverse() : [ ...set ];
}

function flattenArray(array) {
  var _step, flattened = [], _iterator = _createForOfIteratorHelper(array);
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done; ) {
      var _item = _step.value, itemsToInsert = isArray(_item) ? flattenArray(_item) : [ _item ];
      flattened.push(...itemsToInsert);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return flattened;
}

function noop() {}

class Merge {
  static overwrite() {
    var object_ = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : object();
    return new Merge(object_);
  }
  static delete() {}
  constructor() {
    var object_ = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : object();
    keys(object_).forEach(key => {
      this[key] = object_[key];
    });
  }
}

function deepMerge() {
  for (var _len2 = arguments.length, objects = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) objects[_key2] = arguments[_key2];
  return deepmerge__default.default.all(objects, {
    isMergeableObject: isPlainObject
  });
}

function clamp(_ref) {
  var min = _ref.min, max = _ref.max, value = _ref.value;
  return value < min ? min : value > max ? max : value;
}

function last(array) {
  return array[array.length - 1];
}

function sort(array, compareFn) {
  return [ ...array ].map((value, index) => ({
    value: value,
    index: index
  })).sort((a, b) => compareFn(a.value, b.value) || a.index - b.index).map(_ref2 => _ref2.value);
}

function get(path, obj, fallback) {
  if (!path || isEmptyArray(path)) return isUndefined(obj) ? fallback : obj;
  isString(path) && (path = path.split("."));
  for (var ii = 0, length_ = path.length; ii < length_ && obj; ++ii) {
    if (!isPlainObject(obj) && !isArray(obj)) return fallback;
    obj = obj[path[ii]];
  }
  return isUndefined(obj) ? fallback : obj;
}

function makeFunctionForUniqueBy(value) {
  return item => get(value, item);
}

function uniqueBy(array, getValue) {
  var _step2, fromStart = arguments.length > 2 && void 0 !== arguments[2] && arguments[2], unique = [], found = new Set, getter = isFunction(getValue) ? getValue : makeFunctionForUniqueBy(getValue), list = fromStart ? [ ...array ].reverse() : array, _iterator2 = _createForOfIteratorHelper(list);
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
      var _item2 = _step2.value, _value = getter(_item2);
      found.has(_value) || (found.add(_value), unique.push(_item2));
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  return fromStart ? unique.reverse() : unique;
}

function range(start, end) {
  return isNumber(end) ? start <= end ? Array.from({
    length: end + 1 - start
  }, (_, index) => index + start) : Array.from({
    length: start + 1 - end
  }, (_, index) => -1 * index + start) : Array.from({
    length: Math.abs(start)
  }, (_, index) => (start < 0 ? -1 : 1) * index);
}

function within(value) {
  for (var _len3 = arguments.length, rest = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) rest[_key3 - 1] = arguments[_key3];
  var numbers = rest.filter(isNumber);
  return value >= Math.min(...numbers) && value <= Math.max(...numbers);
}

function hasOwnProperty(object_, key) {
  return Object.prototype.hasOwnProperty.call(object_, key);
}

function getLazyArray(value) {
  return isFunction(value) ? value() : value;
}

var ERROR_INFORMATION_URL = "https://remirror.io/docs/errors", errorMessageMap = {};

function isErrorConstant(code) {
  return isString(code) && includes(values(coreConstants.ErrorConstant), code);
}

function createErrorMessage(code, extraMessage) {
  var message = errorMessageMap[code], prefix = message ? "".concat(message, "\n\n") : "", customMessage = extraMessage ? "".concat(extraMessage, "\n\n") : "";
  return "".concat(prefix).concat(customMessage, "For more information visit ").concat(ERROR_INFORMATION_URL, "#").concat(code.toLowerCase());
}

class RemirrorError extends makeError.BaseError {
  static create() {
    return new RemirrorError(arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {});
  }
  constructor() {
    var errorCode, _ref = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {}, code = _ref.code, message = _ref.message;
    isErrorConstant(code) ? (super(createErrorMessage(code, message)), errorCode = code) : super(createErrorMessage(errorCode = coreConstants.ErrorConstant.CUSTOM, message)), 
    this.errorCode = errorCode;
  }
}

function invariant(condition, options) {
  if (!condition) throw RemirrorError.create({
    code: coreConstants.ErrorConstant.PROD
  });
}

var freeze = function(target) {
  return target;
};

Object.defineProperty(exports, "omit", {
  enumerable: !0,
  get: function() {
    return omit__default.default;
  }
}), Object.defineProperty(exports, "pick", {
  enumerable: !0,
  get: function() {
    return object_pick__default.default;
  }
}), Object.defineProperty(exports, "camelCase", {
  enumerable: !0,
  get: function() {
    return caseAnything.camelCase;
  }
}), Object.defineProperty(exports, "capitalCase", {
  enumerable: !0,
  get: function() {
    return caseAnything.capitalCase;
  }
}), Object.defineProperty(exports, "constantCase", {
  enumerable: !0,
  get: function() {
    return caseAnything.constantCase;
  }
}), Object.defineProperty(exports, "kebabCase", {
  enumerable: !0,
  get: function() {
    return caseAnything.kebabCase;
  }
}), Object.defineProperty(exports, "pascalCase", {
  enumerable: !0,
  get: function() {
    return caseAnything.pascalCase;
  }
}), Object.defineProperty(exports, "pathCase", {
  enumerable: !0,
  get: function() {
    return caseAnything.pathCase;
  }
}), Object.defineProperty(exports, "snakeCase", {
  enumerable: !0,
  get: function() {
    return caseAnything.snakeCase;
  }
}), Object.defineProperty(exports, "spaceCase", {
  enumerable: !0,
  get: function() {
    return caseAnything.spaceCase;
  }
}), Object.defineProperty(exports, "debounce", {
  enumerable: !0,
  get: function() {
    return throttleDebounce.debounce;
  }
}), Object.defineProperty(exports, "throttle", {
  enumerable: !0,
  get: function() {
    return throttleDebounce.throttle;
  }
}), exports.Cast = Cast, exports.Merge = Merge, exports.RemirrorError = RemirrorError, 
exports.bool = bool, exports.callIfDefined = callIfDefined, exports.capitalize = capitalize, 
exports.clamp = clamp, exports.cleanupOS = cleanupOS, exports.clone = clone, exports.deepMerge = deepMerge, 
exports.entries = entries, exports.findMatches = findMatches, exports.flattenArray = flattenArray, 
exports.format = format, exports.freeze = freeze, exports.get = get, exports.getLazyArray = getLazyArray, 
exports.hasOwnProperty = hasOwnProperty, exports.includes = includes, exports.invariant = invariant, 
exports.isAndroidOS = isAndroidOS, exports.isArray = isArray, exports.isBoolean = isBoolean, 
exports.isClass = isClass, exports.isDate = isDate, exports.isDirectInstanceOf = isDirectInstanceOf, 
exports.isEmptyArray = isEmptyArray, exports.isEmptyObject = isEmptyObject, exports.isEqual = isEqual, 
exports.isError = isError, exports.isFunction = isFunction, exports.isIdentifierOfType = isIdentifierOfType, 
exports.isInstanceOf = isInstanceOf, exports.isInteger = isInteger, exports.isMap = isMap, 
exports.isNativePromise = isNativePromise, exports.isNull = isNull, exports.isNullOrUndefined = isNullOrUndefined, 
exports.isNumber = isNumber, exports.isObject = isObject, exports.isPlainObject = isPlainObject, 
exports.isPrimitive = isPrimitive, exports.isPromise = isPromise, exports.isRegExp = isRegExp, 
exports.isRemirrorType = isRemirrorType, exports.isSafeInteger = isSafeInteger, 
exports.isSet = isSet, exports.isString = isString, exports.isSymbol = isSymbol, 
exports.isUndefined = isUndefined, exports.keys = keys, exports.last = last, exports.noop = noop, 
exports.not = not, exports.object = object, exports.omitUndefined = omitUndefined, 
exports.randomFloat = randomFloat, exports.randomInt = randomInt, exports.range = range, 
exports.shallowClone = shallowClone, exports.sort = sort, exports.startCase = startCase, 
exports.take = take, exports.toString = toString, exports.uniqueArray = uniqueArray, 
exports.uniqueBy = uniqueBy, exports.uniqueId = uniqueId, exports.values = values, 
exports.within = within;
